package data;

import java.util.logging.Formatter;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.LogRecord;

public class HTMLFormatter extends Formatter {
	private int rowCount = 0;
	
	/**
	 * Constructor 
	 */
	public HTMLFormatter() {

	}

	/**
	 * Zorgt dat de meldingen netjes opgeslagen worden
	 */
	public String format(LogRecord record) {
		StringBuffer buf = new StringBuffer();
		
		// ? == then // : == else
		buf.append("\t<tr bgcolor=\"" + ((rowCount++ % 2 == 0) ? "#FFFFFF" : "#EFEFEF") + "\">\n");

		//Als het een waarschuwing is wordt het veld dik weergegeven.
		if (record.getLevel().intValue() >= Level.WARNING.intValue())
			buf.append("\t\t<td><b>" + record.getLevel() + "</b></td>\n");
		else 
			buf.append("\t\t<td>" + record.getLevel() + "</td>\n");
		
		buf.append("\t\t<td>" + record.getMillis() + "</td>\n");
		buf.append("\t\t<td>" + record.getMessage() + "</td>");
		buf.append("\t</tr>\n");
		
		return buf.toString();
	}

	/**
	 * Maak de HTML Header aan.
	 */
	public String getHead(Handler h) {
		StringBuffer buf = new StringBuffer();

		buf.append("<html>\n");
		buf.append("<head>\n");
		buf.append("\t<title>Logging Mailserver</title>\n");
		buf.append("</head>\n");
		buf.append("<body>\n");
		buf.append("<p>Logging mailserver.</p>");
		buf.append("<table border=\"0\" cellspacing=\"1\" cellpadding=\"3\">\n");
		
		buf.append("\t\t<td><b>Niveau</b></td>\n");
		buf.append("\t\t<td><b>Milliseconde</b></td>\n");
		buf.append("\t\t<td><b>Omschrijving</b></td>\n");
		
		return buf.toString();
	}

	/**
	 * Maak de HTML Tail aan.
	 */
	public String getTail(Handler h) {
		StringBuffer buf = new StringBuffer();
		
		buf.append("</table>\n");
		buf.append("</body>\n");
		buf.append("</html>\n");
		
		return buf.toString();
	}
}