package data;

import java.io.*;

/**
 * Deze klasse bevat algemene functies voor gebruikers, domeinen en mailboxen.
 * 
 * 
 * @version 0.25
 */

public class User {
	private static String settingsPath = "data/settings/";
	
	
	
	
	
	
	
	/**
	 * Controlleert of het domein lokaal of remote is.
	 * Dit a.d.h.v. het bestaan van het bestand <domein> in settings.
	 * @param mail
	 * @return bestaat wel/niet
	 */
	public static boolean domainExists(String mail){
		File domain;
		String parser = "@";
		
		mail = mail.replace("<", "");
		mail = mail.replace(">", "");
		
		mail = mail.substring(mail.indexOf(parser)+1, mail.length());
		domain = new File(settingsPath+mail);
		
		if (domain.exists()){
			return true;
		}
		else{
			return false;
		}
	}
	
	/**
	 * Controlleert of een gebruiker bestaat.
	 * Dit gebeurd a.d.h.v. de ingegeven gebruikers in het bestand <domein> onder settings.
	 * @param mail
	 * @return bestaat wel/niet
	 */
	public static boolean userExists(String mail){
		String parser = "@";
		String domain;
		String user;
		String tmp;
		File fileDomain;
		BufferedReader in;
		
		mail = mail.replace("<", "");
		mail = mail.replace(">", "");
		
		//domain en user loskoppen van mail
		user = mail.substring(0, mail.indexOf(parser));
		domain = mail.substring(mail.indexOf(parser)+1, mail.length());
		fileDomain = new File(settingsPath+domain);
		
		//Spatie problemen met Windows voorkomen
		user = user.trim();
		domain = domain.trim();
		
		String[] credentials;
		//Controleren op bestaan bestand
		if (fileDomain.exists()){
			try{ 
				in = new BufferedReader(new FileReader(fileDomain));
				while ((tmp = in.readLine()) != null){
					//Passwoord loskoppelen
					credentials = tmp.split("\t");
					if (user.equalsIgnoreCase(credentials[0])){
						in.close();
						return true;
					}
				}
				in.close();
				return false;
			}
			catch(Exception ex){
				ex.printStackTrace();
				return false;
			}
		}
		else{
			return false;
		}		
	}
	
	/**
	 * Controlleert de gebruiker credentials.
	 * Geeft true terug als de gebruiker is geauthenticeerd.
	 * 
	 * @param email
	 * @param password
	 * @return
	 */
	public static boolean checkCredentials(String email, String password){
		String parser = "@";
		String domain;
		String user;
		String tmp;
		File fileDomain;
		BufferedReader in;
		
		email = email.replace("<", "");
		email = email.replace(">", "");
		
		//domain en user loskoppen van mail
		user = email.substring(0, email.indexOf(parser));
		domain = email.substring(email.indexOf(parser)+1, email.length());
		fileDomain = new File(settingsPath+domain);
		
		String[] credentials;
		//Controleren op bestaan bestand
		try{ 
			in = new BufferedReader(new FileReader(fileDomain));
			while ((tmp = in.readLine()) != null){
				//Passwoord loskoppelen
				credentials = tmp.split("\t");
				if ((user.equalsIgnoreCase(credentials[0])) && (password.equals(credentials[1]))){
					in.close();
					return true;
				}
			}
			in.close();
			return false;
		} 
		catch(Exception ex){
			ex.printStackTrace();
			return false;
		}

	}
	
	
}
