
package pop3Server;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;

import data.*;

public class TRANSACTIONState extends POP3State {
	//static ArrayList<Message> deletedMsg;
	//private String deletedMsg = "";//Sla te verwijderen berichten id's op gescheiden door ;
	private ArrayList deleteMsg = new ArrayList();

	public TRANSACTIONState(){
		//transferState = true;
	}

	public String cmdUSER(POP3ClientHandler pop3CH, String cmdArgs) {		
		return ERR + " Ongeldig commando; geldige commando's: LIST, RETR, DELE";
	}
	
	public String cmdPASS(POP3ClientHandler pop3CH, String cmdArgs) {
		return ERR + " Ongeldig commando; geldige commando's: LIST, RETR, DELE";
	}
	
	public String cmdSTAT(POP3ClientHandler pop3CH, String cmdArgs, String host) {
		String msgSTAT;
		//Wat doet deze code? stat telt toch juist het aantal bytes op?
		if((msgSTAT = Message.getMessageStat(domain))!= null)
		{
			//MessageStat splitsen
			return  OK +" "+ msgSTAT;
		}
		
		else 
			return ERR;
	}
	
	public String cmdLIST(POP3ClientHandler pop3CH, String cmdArgs) {
		String msgList;
		if((msgList = Message.getMessageList(domain, 0))!= null)
		{
			return OK + " Lijst volgt" + System.getProperty("line.separator") + msgList;
		}
		else 
			return ERR + "Geen berichten gevonden.";
	}
	
	public String cmdRETR(POP3ClientHandler pop3CH, String cmdArgs) {
		Message msgRETR;
		String response;
		int msgID = Integer.parseInt(cmdArgs);
		if((msgRETR = Message.getMessage(domain, msgID))!= null)
		{	//Let OP! Windows en Linux hebben een verschil in newline (Linux == \n), (Windows == \r\n)
			response = OK + " " + Message.getMessageList(domain, msgID) + "\r\n" + msgRETR.getData() + "\r\n" + ".";//+temp;
			if (System.getProperty("os.name").equalsIgnoreCase("Linux")){
				response = response + "\r";
			}
			return response;
		}
		else 
			return ERR + "Bericht niet gevonden";
	}
	
	public String cmdDELE(POP3ClientHandler pop3CH, String cmdArgs){		
				
		deleteMsg.add(Integer.parseInt(cmdArgs));
		
		return OK;
	}

	public String cmdNOOP(POP3ClientHandler pop3CH, String cmdArgs) {
		// Return always a positive response
		return OK;
	}
	
	public String cmdRSET(POP3ClientHandler pop3CH) {
		deleteMsg.clear();
		return OK;
	}
	
	public String cmdQUIT(POP3ClientHandler pop3CH, String cmdArgs){// nog verder uitzoeken
		pop3CH.setState(new UPDATEState(deleteMsg));
		//return "QUITTRANS";
		return "QUIT";
	}

	/**
	 * Implementatie van het TOP commando.
	 */
	public String cmdTOP(POP3ClientHandler pop3CH, String cmdArgs){
		Message msg;
		int msgID;
		int lines = 0;
		String parser = " ";
		String response = "";
		String msgData;
		String tmp;
		
		//cmdArgs == id lines
		if (cmdArgs.contains(parser)){
			msgID = Integer.parseInt(cmdArgs.substring(0, cmdArgs.indexOf(parser)));
			tmp = cmdArgs.substring(0, cmdArgs.indexOf(parser));
			lines = Integer.parseInt(cmdArgs.substring(cmdArgs.indexOf(parser)+1));
		}
		else {
			msgID = Integer.parseInt(cmdArgs);
		}
		
		//Bericht ophalen
		msg = Message.getMessage(domain, msgID);
		
		//Aantal regels uitlezen		
		msgData = msg.getData();
		BufferedReader reader = new BufferedReader(new StringReader(msgData));
		if (lines > 0){
			int i = 0;
			try {
				while ((tmp = reader.readLine()) != null && (lines != i)) {
					response = response + tmp + System.getProperty("line.separator");
					i = i+1;
				}
			}
			catch(IOException e) {
				e.printStackTrace();
			}
		}
		else{
			//Nog aanpassen zodag bij 0 ook echt alleen de HEAD wordt weergegeven
			try{
				while ((tmp = reader.readLine()) != null){
					if (!tmp.equals("")){
						response = response + tmp + System.getProperty("line.separator");
					}
					else{
						break;
					}
						
				}
			}
			catch(IOException e){
				e.printStackTrace();
			}
		}
		
		response = response + "\r\n\r\n.\r\n";
		if (System.getProperty("os.name").equalsIgnoreCase("Linux")){
			response = response + "\r";
		}
		
		return OK + " \r\n" + response;	
	}
	
	/**
	 * Show lijst met Mail ID's en de Unieke ID's.
	 */
	public String cmdUIDL(POP3ClientHandler pop3CH, String cmdArgs) {
		String response;
		if (cmdArgs == null){
			response = OK + " Lijst volgt" + System.getProperty("line.separator") + Message.getMessageUID(domain, 0);
			response = response + ".";
		}
		else{
			response = OK + " " + System.getProperty("line.separator") + Message.getMessageUID(domain, Integer.parseInt(cmdArgs));
		}
		if (System.getProperty("os.name").equalsIgnoreCase("Linux")){
			response = response + "\r";
		}
		//System.out.println("DEBUG: " + response);
		return response;
	}
	

	
}
