package relayServer;

import data.Message;
import java.io.*;

/**
 * DATA state.
 * Vanuit de DATA state wordt geprobeerd het bericht te verzenden.
 * Dit gebeurd door het bericht regel voor regel naar de server te sturen.
 * Hierna wordt het bericht afgesloten met crlf . crlf en wordt de verbinding verbroken.
 * 
 * @version 0.50
 */
public class DATAState extends RLYState {

	public void doNextCmd(RelayServer rs, Message msg) {
		String line;
		String parser =  " ";
		String tmpData = msg.getData();
		String tmp;
		
		//Bericht regel voor regel verzenden
		BufferedReader reader = new BufferedReader(new StringReader(tmpData));
		try {
			while ((tmp = reader.readLine()) != null) {
				rs.setOutput(tmp);
	        }
		}
		catch(IOException e) {
			e.printStackTrace();
		}
				
		//Bericht afsluiten.
		rs.setOutput(".");
		line = rs.getInput();
		line = line.substring(0, line.indexOf(parser));
		if (line.equals("250")){
			//Bericht verzonden
			state = false;
			sent = true;
			rs.setOutput("QUIT");
		}
		else{
			//Bericht niet verzonden
			sent = false;
			state = false;
		}		
	}
}