package smtpServer;

import data.*;

/**
 * MAIL State.
 * In de MAIL status wordt de ontvanger bekend gemaakt.
 * Hiervoor wordt er gecontrolleerd of het domain wel bestaat op deze server.
 * Zo ja wordt er gekeken of de mailbox van de gebruiker bestaat.
 * Zo nee, wordt er aangegeven dat het bericht gerelayed wordt.
 * 
 * @version 0.50
 */

public class MAILState extends SMTPState {

	public String cmdDATA(SMTPClientHandler smtpCH, String cmdArgs) {
		return REPLY_500;
	}

	public String cmdEndData(SMTPClientHandler smtpCH, String cmdArgs) {
		return REPLY_500;
	}

	public String cmdHELO(SMTPClientHandler smtpCH, String cmdArgs, String host) {
		return REPLY_500;
	}

	public String cmdMAIL(SMTPClientHandler smtpCH, String cmdArgs) {
		return "503 MAIL is reeds uitgevoerd.";
	}

	public String cmdRCPT(SMTPClientHandler smtpCH, String cmdArgs) {
		String parser = "TO:";
		if (cmdArgs == null){
			return "501 Ongeldige invoer. (vb. 'RCPT TO:wie@domein.nl')";
		}
		else if (cmdArgs.length() <= parser.length()){
			return "501 Ongeldige invoer. (vb. 'RCPT TO:wie@domein.nl')";
		}
		else if (!cmdArgs.substring(0, parser.length()).toUpperCase().equals(parser)){
			return "501 Ongeldige invoer. (vb. 'RCPT TO:wie@domein.nl')";
		}
		else if (!isValidMail(cmdArgs)){
			return "501 Ongeldige invoer. (vb. 'MAIL FROM: ik@jouwdomein.nl')";
		}
		else{
			//Echte adres in de to variabele zetten
			cmdArgs = cmdArgs.substring(parser.length());
			//Controleren of de geadresseerde wel bestaat.
			if (User.domainExists(cmdArgs)){
				if (User.userExists(cmdArgs)){
					msg.setTo(cmdArgs);
					smtpCH.setState(new RCPTState());
					return "250 OK Mail naar "+cmdArgs;
				}
				else{
					return "550 Mailbox bestaat niet.";
				}
			}
			else{
				//Relay
				msg.setTo(cmdArgs);
				smtpCH.setState(new RCPTState());
				return "250 OK Mail naar "+cmdArgs+ " (remote)";				
			}
				
		}
	}

}
